import request from '@/utils/request';
import type { ApiResult, PageResult } from '@/api';
import type { BookingField, BookingFieldParam } from './model';
import { MODULES_API_URL } from '@/config/setting';

/**
 * 分页查询场馆场地
 */
export async function pageBookingField(params: BookingFieldParam) {
  const res = await request.get<ApiResult<PageResult<BookingField>>>(
    MODULES_API_URL + '/booking/booking-field/page',
    {
      params
    }
  );
  if (res.data.code === 0) {
    return res.data.data;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 查询场馆场地列表
 */
export async function listBookingField(params?: BookingFieldParam) {
  const res = await request.get<ApiResult<BookingField[]>>(
    MODULES_API_URL + '/booking/booking-field',
    {
      params
    }
  );
  if (res.data.code === 0 && res.data.data) {
    return res.data.data;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 添加场馆场地
 */
export async function addBookingField(data: BookingField) {
  const res = await request.post<ApiResult<unknown>>(
    MODULES_API_URL + '/booking/booking-field',
    data
  );
  if (res.data.code === 0) {
    return res.data.message;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 修改场馆场地
 */
export async function updateBookingField(data: BookingField) {
  const res = await request.put<ApiResult<unknown>>(
    MODULES_API_URL + '/booking/booking-field',
    data
  );
  if (res.data.code === 0) {
    return res.data.message;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 删除场馆场地
 */
export async function removeBookingField(id?: number) {
  const res = await request.delete<ApiResult<unknown>>(
    MODULES_API_URL + '/booking/booking-field/' + id
  );
  if (res.data.code === 0) {
    return res.data.message;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 批量删除场馆场地
 */
export async function removeBatchBookingField(data: (number | undefined)[]) {
  const res = await request.delete<ApiResult<unknown>>(
    MODULES_API_URL + '/booking/booking-field/batch',
    {
      data
    }
  );
  if (res.data.code === 0) {
    return res.data.message;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 根据id查询场馆场地
 */
export async function getBookingField(id: number) {
  const res = await request.get<ApiResult<BookingField>>(
    MODULES_API_URL + '/booking/booking-field/' + id
  );
  if (res.data.code === 0 && res.data.data) {
    return res.data.data;
  }
  return Promise.reject(new Error(res.data.message));
}
